// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../../../../packages/inferno/inferno-shared
//   ../../../../packages/inferno/inferno-vnode-flags

declare module 'inferno' {
    import { LifecycleClass as _LifecycleClass, NO_OP } from 'inferno-shared';
    import _VNodeFlags from 'inferno-vnode-flags';
    import { IFiber, Fiber } from 'inferno/core/fiber';
    import { getFlagsForElementVnode, normalize as internal_normalize } from 'inferno/core/normalization';
    import { options } from 'inferno/core/options';
    import { createVNode, InfernoChildren, Props, Refs, IVNode } from 'inferno/core/vnode';
    import { isUnitlessNumber as internal_isUnitlessNumber } from 'inferno/DOM/constants';
    import { linkEvent } from 'inferno/DOM/events/linkEvent';
    import { patch as internal_patch } from 'inferno/DOM/patching';
    import { componentToDOMNodeMap as internal_DOMNodeMap, createRenderer, findDOMNode, render } from 'inferno/DOM/rendering';
    import { EMPTY_OBJ } from 'inferno/DOM/utils';
    import { mount } from 'inferno/DOM/mounting';
    export const VNodeFlags: _VNodeFlags;
    export const LifecycleClass: _LifecycleClass;
    const version = "4.0.0";
    export { EMPTY_OBJ, IFiber, InfernoChildren, IVNode, Fiber, NO_OP, Props, Refs, createRenderer, createVNode, findDOMNode, getFlagsForElementVnode, internal_DOMNodeMap, internal_isUnitlessNumber, internal_normalize, internal_patch, linkEvent, mount, options, render, version };
}

declare module 'inferno/core/fiber' {
    import { LifecycleClass } from 'inferno-shared';
    import { IVNode } from 'inferno/core/vnode';
    export const enum FiberFlags {
        Text = 1,
        HasNoChildren = 2,
        HasKeyedChildren = 4,
        HasNonKeydChildren = 8,
        HasSingleChildren = 16,
        hasEvents = 32,
    }
    export interface IFiber {
        input: IVNode | string | number;
        children: null | IFiber | IFiber[];
        childrenKeys: Map<string | number, number>;
        dom: null | Element;
        lifeCycle: LifecycleClass;
        i: string | number;
        c: any;
        flags: number;
    }
    /**
      * Fiber represents internal vNode tree, which holds the reference to actual DOM.
      * This way user land virtual nodes become stateless and can be moved / hoisted / swapped freely at application level
      * @param {object|string|number} input reference to vNode or string of this Fiber
      * @param {string} i location of current Fiber in fiber tree
      * @constructor
      */
    export function Fiber(input: any, i: any): void;
}

declare module 'inferno/core/normalization' {
    import { IVNode } from 'inferno/core/vnode';
    export function getFlagsForElementVnode(type: string): number;
    export function normalize(vNode: IVNode): void;
}

declare module 'inferno/core/options' {
    import { IFiber } from 'inferno/core/fiber';
    export const options: {
        afterMount: null | Function;
        afterRender: null | Function;
        afterUpdate: null | Function;
        beforeRender: null | Function;
        beforeUnmount: null | Function;
        createVNode: null | Function;
        component: {
            create: null | Function;
            flush: null | Function;
            handleInput: null | Function;
            patch: null | Function;
            rendering: boolean;
        };
        findDOMNodeEnabled: boolean;
        recyclingEnabled: boolean;
        roots: Map<any, IFiber>;
    };
}

declare module 'inferno/core/vnode' {
    import VNodeFlags from 'inferno-vnode-flags';
    export type Ref = (node?: Element | null) => void | null;
    export type InfernoChildren = string | number | boolean | undefined | IVNode | Array<string | number | IVNode> | null;
    export type Type = string | null | Function;
    export interface Props {
        children?: InfernoChildren;
        [k: string]: any;
    }
    export interface Refs {
        onComponentDidMount?: (domNode: Element) => void;
        onComponentWillMount?(): void;
        onComponentShouldUpdate?(lastProps: any, nextProps: any): boolean;
        onComponentWillUpdate?(lastProps: any, nextProps: any): void;
        onComponentDidUpdate?(lastProps: any, nextProps: any): void;
        onComponentWillUnmount?(domNode: Element): void;
    }
    export interface IVNode {
        children: InfernoChildren;
        className: string;
        flags: VNodeFlags;
        key: any;
        props: Props | null;
        ref: Ref | Refs;
        type: Type;
    }
    /**
      * Creates virtual node
      * @param {number} flags
      * @param {string|Function|null} type
      * @param {string|null=} className
      * @param {object=} children
      * @param {object=} props
      * @param {*=} key
      * @param {object|Function=} ref
      * @returns {VNode} returns new virtual node
      */
    export function createVNode(flags: VNodeFlags, type: Type, className?: string | null, children?: InfernoChildren, props?: Props | null, key?: any, ref?: Ref | Refs): any;
    export function isVNode(o: IVNode): boolean;
}

declare module 'inferno/DOM/constants' {
    /**
        * @module Inferno
        */ /** TypeDoc Comment */
    export const xlinkNS = "http://www.w3.org/1999/xlink";
    export const xmlNS = "http://www.w3.org/XML/1998/namespace";
    export const svgNS = "http://www.w3.org/2000/svg";
    export const strictProps: Set<string>;
    export const booleanProps: Set<string>;
    export const namespaces: Map<string, string>;
    export const isUnitlessNumber: Set<string>;
    export const skipProps: Set<string>;
    export const delegatedEvents: Set<string>;
}

declare module 'inferno/DOM/events/linkEvent' {
    /**
      * Links given data to event as first parameter
      * @param {*} data data to be linked, it will be available in function as first parameter
      * @param {Function} event Function to be called when event occurs
      * @returns {{data: *, event: Function}}
      */
    export function linkEvent(data: any, event: any): {
        data: any;
        event: any;
    } | null;
}

declare module 'inferno/DOM/patching' {
    import { LifecycleClass } from "inferno-shared";
    import { IFiber } from "inferno/core/fiber";
    import { IVNode } from "inferno/core/vnode";
    export function patch(fiber: IFiber, nextInput: IVNode | string | number, parentDom: Element, lifecycle: LifecycleClass, context: any, isSVG: boolean, isRecycling: boolean): void;
    export function patchElement(fiber: IFiber, lastVNode: IVNode, nextVNode: IVNode, parentDom: Element | null, lifecycle: LifecycleClass, context: Object, isSVG: boolean, isRecycling: boolean): void;
    export function patchComponent(fiber: any, lastVNode: IVNode, nextVNode: IVNode, parentDom: Element, lifecycle: LifecycleClass, context: any, isSVG: boolean, isClass: boolean, isRecycling: boolean): boolean;
    export function patchText(fiber: IFiber, text: string | number): void;
    export function patchNonKeyedChildren(childFibers: IFiber[], nextChildren: any, dom: any, lifecycle: LifecycleClass, context: Object, isSVG: boolean, isRecycling: boolean, lastFibersLength: number): void;
    export function patchKeyedChildren(parentFiber: IFiber, childFibers: IFiber[], nextChildren: any, dom: any, lifecycle: LifecycleClass, context: Object, isSVG: boolean, isRecycling: boolean, lastFibersLength: number, nextChildrenLength: number): void;
    export function isAttrAnEvent(attr: string): boolean;
    export function patchProp(prop: any, lastValue: any, nextValue: any, dom: Element, isSVG: boolean, hasControlledValue: boolean): void;
    export function patchEvent(name: string, lastValue: any, nextValue: any, dom: any): void;
}

declare module 'inferno/DOM/rendering' {
    import { InfernoChildren, IVNode } from 'inferno/core/vnode';
    export const componentToDOMNodeMap: Map<any, any>;
    /**
        * When inferno.options.findDOMNOdeEnabled is true, this function will return DOM Node by component instance
        * @param ref Component instance
        * @returns {*|null} returns dom node
        */
    export function findDOMNode(ref: any): any;
    /**
        * Renders virtual node tree into parent node.
        * @param {IVNode | null | string | number} input input to be rendered
        * @param {*} parentDom DOM node which content will be replaced by virtual node
        * @param {Function?} callback Callback to be called after rendering has finished
        * @returns {InfernoChildren} rendered virtual node
        */
    export function render(input: IVNode | null | string | undefined, parentDom: Element | SVGAElement | DocumentFragment | null | HTMLElement | Node, callback?: Function): InfernoChildren;
    export function createRenderer(parentDom?: any): (lastInput: any, nextInput: any) => void;
}

declare module 'inferno/DOM/utils' {
    import { LifecycleClass } from 'inferno-shared';
    import { IVNode } from 'inferno/core/vnode';
    import { IFiber } from 'inferno/core/fiber';
    export const EMPTY_OBJ: {};
    export function replaceDOM(fiber: IFiber, parentDom: any, newDOM: any, lifecycle: LifecycleClass, isRecycling: any): void;
    export function handleComponentInput(input: any): any;
    export function setTextContent(dom: any, text: string | number): void;
    export function updateTextContent(dom: any, text: string | number): void;
    export function appendChild(parentDom: any, dom: any): void;
    export function insertOrAppend(parentDom: any, newNode: any, nextNode: any): void;
    export function documentCreateElement(tag: any, isSVG: boolean): Element;
    export function replaceWithNewNode(fiber: IFiber, nextNode: IVNode, parentDom: any, lifecycle: LifecycleClass, context: Object, isSVG: boolean, isRecycling: boolean): void;
    export function replaceChild(parentDom: any, nextDom: any, lastDom: any): void;
    export function removeChild(parentDom: Element, dom: Element): void;
    export function removeAllChildren(dom: Element, children: IFiber[], lifecycle: LifecycleClass, isRecycling: boolean): void;
    export const G: any;
    export function isKeyed(nextChildren: IVNode[]): boolean;
}

declare module 'inferno/DOM/mounting' {
    import { LifecycleClass } from 'inferno-shared';
    import { IVNode } from 'inferno/core/vnode';
    import { IFiber } from 'inferno/core/fiber';
    export function mount(fiber: IFiber, input: IVNode | string | number, parentDom: Element | null, lifecycle: LifecycleClass, context: Object, isSVG: boolean): any;
    export function mountText(fiber: IFiber, text: string | number, parentDom: Element | null): any;
    export function mountElement(fiber: IFiber, vNode: IVNode, parentDom: Element | null, lifecycle: LifecycleClass, context: {}, isSVG: boolean): Element;
    export function mountArrayChildren(fiber: any, children: any, dom: Element, lifecycle: LifecycleClass, context: Object, isSVG: boolean, prefix: string, isKeyed: boolean, counter: number): void;
    export function mountComponent(fiber: IFiber, vNode: IVNode, parentDom: Element | null, lifecycle: LifecycleClass, context: Object, isSVG: boolean, isClass: boolean): null;
    export function mountClassComponentCallbacks(vNode: IVNode, ref: any, instance: any, lifecycle: LifecycleClass): void;
    export function mountFunctionalComponentCallbacks(ref: any, dom: any, lifecycle: LifecycleClass): void;
    export function mountRef(dom: Element, value: any, lifecycle: LifecycleClass): void;
}

